# -*- coding: utf-8 -*-
#
# w.c.s. - web application for online forms
# Copyright (C) 2005-2010  Entr'ouvert
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

import time

from quixote import get_publisher, get_request
from quixote.html import TemplateIO, htmltext

from qommon import _, misc


def last_modification_block(obj):
    r = TemplateIO(html=True)
    if obj.last_modification_time:
        warning_class = ''
        if (time.time() - time.mktime(obj.last_modification_time)) < 600:
            if get_request().user and str(get_request().user.id) != obj.last_modification_user_id:
                warning_class = 'recent'
        r += htmltext('<p class="last-modification %s">') % warning_class
        r += _('Last Modification:')
        r += ' '
        r += misc.localstrftime(obj.last_modification_time)
        r += ' '
        if obj.last_modification_user_id:
            try:
                r += _('by %s') % get_publisher().user_class.get(
                                obj.last_modification_user_id).display_name
            except KeyError:
                pass
        r += htmltext('</p>')

    return r.getvalue()
